/*************************************************************************
* 	FILE:	display.h
*	AUTHOR: CALeague
*	DATE:	25 April 1993
*	PURPOSE:
*	  A display is a viewport which can contain "screen objects",
*	  such as windows and buttons.
**************************************************************************/

#ifndef _DISPLAY_H
#define _DISPLAY_H

#include "viewport.h"
#include "scrnobj.h"

class Display : public Viewport
{
  ScrnObjList list;
public:
  Display (void) { }
  Display (Viewport* parent, int x1, int y1, int x2, int y2)
    : Viewport (parent, x1, y1, x2, y2) { }
  ~Display (void) { Erase (); }

  virtual void Add (ScrnObj *a, int x, int y);
  virtual void Draw (void);
  virtual void Erase (void);

  virtual Message Dispatch (Message&);
};


extern Display theDisplay;    	// "root" display (physical screen)


#endif

