// ******************************************************************
// * TITLE: infowin.c                                               *
// * AUTHOR: Steven Winig                                           *
// * DATE: May 1, 1993                                              *
// * Purpose: Create display info Window for main screen            *
// ******************************************************************

#include "window.h"
#include "infowin.h"
#include "checkbox.h"
#include "scrnobj.h"

	// temporary??
#include "players.h"
#include "ufwoom.h"

#include <alloc.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

InfoWindow::InfoWindow ()
{
  XDim = InfoXDim;  YDim = InfoYDim;
  CliX1 = CliY1 = CliX2 = CliY2 = 0;
  TX1 = TY1 = TX2 = TY2 = 0;
  BorderColor = RED;
  BkColor = LIGHTGRAY;
  TitleColor = WHITE;
  Title = NULL;
//  Title = new char [15];
//  assert (Title != 0);
//  strcpy (Title, "Mark's Mind");
  ClientD = TitleD = NULL;
  Drawn = False;
}

void InfoWindow::Init (Display *d, int x, int y)
{
  Disp = d;
  X = x;  Y = y;

  CalcBorder ();
  if (Title)
  {
    CalcTitle ();
    TitleD = new Display (Disp, TX1, TY1, TX2, TY2);
    assert (TitleD != 0);
    TitleD->SetBkColor (BorderColor);
    TitleD->SetTextJustify (CENTER_TEXT, TOP_TEXT);
    TitleD->SetTextStyle (TitleFont, HORIZ_DIR, TitleFontSize);
    TitleD->SetColor (TitleColor);
  }
  ClientD = new Display (Disp, CliX1, CliY1, CliX2, CliY2);
  assert (ClientD != 0);
  ClientD->SetBkColor (BkColor);
}


void InfoWindow::Draw (void)
{
  char buf[40];

  if (!Drawn)
  {
    assert (Disp != NULL);
    Disp->FastDraw ();
    PrepScreen ();
    DrawBorder ();
    if (TitleD)
      DrawTitle ();
    ClientD->Clear ();
    ClientD->Draw ();
    Disp->Done ();
    Drawn = True;

    // Add text to window
    ClientD->SetColor(BLACK);
    ClientD->SetTextStyle(GOTHIC_FONT, HORIZ_DIR, 1);
    strcpy(buf, "Scotland Yard");
	ClientD->OutTextXY(ClientD->GetMaxX()/2-ClientD->TextWidth(buf)/2,10, buf);
    ClientD->SetColor(RED);
    strcpy(buf, "London, 1869");
	ClientD->OutTextXY(ClientD->GetMaxX()/2-ClientD->TextWidth(buf)/2+4,33, buf);

  }
}

