/*************************************************************************
* 	FILE:	keybd.h
*	AUTHOR: CALeague
*	DATE:	18 April 1993
*	PURPOSE:
*	  Keybd class serves as an interface between the UI and the
*	  keyboard.  It generates messages based on keyboard events
*	  containing character codes and scan codes.
**************************************************************************/

#ifndef _KEYBD_H
#define _KEYBD_H

#include "messages.h"


/**********************************************************************
*	Keybd Class
***********************************************************************/

class Keybd
{
public:
  Message Event ();			// Get last keybd event (or Idle)
  Message WaitForAnyEvent ();		// Wait for any keybd event
  Message WaitForEvent (Message&);	// Wait for specific keybd event
  void Flush (void);
};


extern Keybd Keys;		// Global instance

#endif

