/**********************************************************************
*       FILE:     LINK.c
*       AUTHOR:   E. Otis Owens
*       DATE:     1 May 1993
*       PURPOSE:
*         There was one before, but thanks to some brilliant design
*         inovations, this class has been scaled back significanly.
*         Its ".c" file is kept here for possible future extensions.
***********************************************************************/

#include "link.h"





/**********************************************************************
*       Public Functions
***********************************************************************/

int Route::find_join(int joinNum) {

  if ( between(joinNum, 0, numJoins) ) return joins[joinNum];
  else {
    cerr << "Join link " << joinNum << " out of range ("
         << 0 << ".." << numJoins << ")\n";
    return 0;  // node 0 points to NULL
  }
}

/************************************************************/

void Route::get_join(int join) {

  int *oldJoins= joins;
  int num= numJoins;

  joins= new int[++numJoins];
  assert ( joins != 0 );
  for (int i= 0; i < num; i++) joins[i]= oldJoins[i];
  joins[num]= join;

  delete oldJoins;
}


