/**********************************************************************
*       FILE:     MAPNODE.h
*       AUTHOR:   E. Otis Owens
*       DATE:     17 April 1993
*       MODIFIED: 30 April 1993 (5:00 pm)
*       PURPOSE:
*         Functions to store and manipulate a node.
***********************************************************************/

#ifndef _MAPNODE_H
#define _MAPNODE_H

#include "link.h"






/**********************************************************************
*       Class Definition
***********************************************************************/

class MapNode {

  Route *links;  // array to store adjacent (linked) nodes
  char  *name;   // stores the name of a node

 public:
  int x, y,      // graphic coordinates of a node
      numLinks,  // number of adjacent (linked) nodes
      numJoins;

  MapNode(void) { numLinks= 0; links= NULL; name= NULL; }
  ~MapNode()    { delete [] links;  delete name; }

  void get_name(char*, int);
  void get_link(int, mode);
  void get_join(int join)
    { if (numLinks > 0) links[numLinks-1].get_join(join); }

  bool is_link(mode);
  bool is_link(int, mode);
  vect find_vector(int);
  int  find_link(int);
  int  find_join(int link, int join) { return links[link].find_join(join); }
  char* find_name(int link) { return name; }

  int  num_joins(int link) { return links[link].numJoins; }

  void show_node(void);
};



#endif









