/*************************************************************************
* 	FILE:	popupwin.c
*	AUTHOR: CALeague
*	DATE:	25 April 1993
*	PURPOSE:
*	  Pop-up windows "memorize" the image which they overwrite when
*	  they are drawn, and restore the image when they are erased.
**************************************************************************/

#include "popupwin.h"
#include <stdlib.h>
#include <assert.h>


void PopUpWin::PrepScreen (void)
{
  if (!buffer)
  {
    buffer = (void *) new byte [imagesize (0, 0, XDim, YDim)];
    assert (buffer != NULL);
  }
  Disp->GetImage (X, Y, X+XDim, Y+YDim, buffer);
}


void PopUpWin::Erase (void)
{
  assert (Disp != NULL);
  if (Drawn)
  {
    ClientD->Erase ();
    Disp->PutImage (X, Y, buffer, COPY_PUT);
    Drawn = False;
  }
}

