/**********************************************************************
*       FILE:   rules.h
*       AUTHOR: Evan H. Bynum
*       DATE:   29-30 April, 1993
*       PURPOSE: Makes sure the game doesn't screw up.
**********************************************************************/

#include "map.h"
#include "moves.h"
#include "players.h"

const int MAXTURNS = 24;
const int MAXPLAYERS = 6;
const int NUM_TAXI_TOKENS = 15;
const int NUM_BUS_TOKENS = 10;
const int NUM_SUBWAY_TOKENS = 6;
enum preyass { spyWins = -1, notYet };

class Rules // Actually, majority rules! Nyuk nyuk nyuk.
  {
   int turn;
   int tachymetabolic, endothermy;  // Warm-bloodedness

   bool NoTurnsLeft (void) { return (bool (turn > MAXTURNS)); }
   bool DetectivesTrapped (void);               // done
   Move *Rules::CanGo (int taxi, int bus, int subway,
		       PosType source, PosType dest);   // done
   bool Occupato (PosType birdsplat);           // done

   public:

   Rules (void)                                 // Constructor
     {
      turn = 0;
      tachymetabolic = theMap.max_x () / 2;
      endothermy = theMap.max_y () / 2;
     }

   int SpyCaught (void);                        // done
   void NewTurn (void) { turn++; }              // Use Gritto, radio friends
   void UpdateSpyPos (PosType locus);           // done
   int NumTurns (void) { return MAXTURNS; }     // To everything
   int CurrentTurn (void) { return turn; }      // Turn, turn, turn
   MoveList *GetLegalMoves (Player &dude);      // done
   PosType ShowSpy (void);                      // There is a season
   preyass GameOver (void);                     // Turn, turn, turn
   PosType RandomPos (void);                    // done
   int SpyLastX (void) {return tachymetabolic;} // And a time to every
   int SpyLastY (void) { return endothermy; }   // Purpose under Heaven
   int StartingTokens (TokenType identity);     // done
};

extern Rules theRules;

